=== .github/ppa-wip/focal/debian/changelog ===
clingcon (1.0.0) focal; urgency=medium

  * initial release

 -- Roland Kaminski <kaminski@cs.uni-potsdam.de>  Fri, 02 Jan 2021 13:32:11 +0100
